/*
 * MenuFrame.java
 *
 * Created on October 26, 2004, 1:54 PM
 *
 * This software is copyright (c) 2004 Board of Regents, University of Wisconsin.
 * All Rights Reserved.
 *
 * FILE:        $Source: /cvs_archive/cvs/validator/plugin/MenuFrame.java,v $
 * 
 * AUTHOR:      $Author: dmaziuk $
 * DATE:        $Date: 2005/06/06 20:26:43 $
 * 
 * UPDATE HISTORY:
 * ---------------
 * $Log: MenuFrame.java,v $
 * Revision 1.7  2005/06/06 20:26:43  dmaziuk
 * Removed UI distinction between "data" and "metadata" validation functions
 *
 * Revision 1.6  2005/03/18 21:16:26  dmaziuk
 * Added new function: InsertDatumCount
 *
 * Revision 1.5  2004/12/14 19:15:59  dmaziuk
 * minor plugin update
 *
 * Revision 1.4  2004/12/01 00:23:07  dmaziuk
 * Added data validation functions.
 *
 * Revision 1.3  2004/11/30 21:37:32  dmaziuk
 * added new class
 * */

/**
 *
 * @author  dmaziuk
 */
public class MenuFrame extends javax.swing.JPanel implements org.gjt.sp.jedit.EBComponent {
    private static final boolean DEBUG = false;
    /** JEdit's view */
    private org.gjt.sp.jedit.View fView = null;
    /** true if window is floating */
    private boolean floating = true;
    /** plugin */
    private StarValidatorPlugin plugin = null;
    /** buffer */
    private StringBuffer fBuf = null;
    /** popup menu */
    private javax.swing.JPopupMenu fPopup = null;
    /** singleton menu window */
    private static MenuFrame fInstance = null;
//******************************************************************************
    /** Returns singleton instance of MenuFrame.
     * @param view JEdit's view
     * @param position floating or docked
     */
    static public MenuFrame createFrame( org.gjt.sp.jedit.View view, String position ) {
        if( fInstance == null ) fInstance = new MenuFrame( view, position );
        return fInstance;
    } //************************************************************************
    /** Creates new form MenuFrame.
     * @param view JEdit's view
     * @param position floating or docked
     */
    private MenuFrame( org.gjt.sp.jedit.View view, String position ) {
        fView = view;
        floating = position.equals( org.gjt.sp.jedit.gui.DockableWindowManager.FLOATING );
        plugin = (StarValidatorPlugin) org.gjt.sp.jedit.jEdit.getPlugin( StarValidatorPlugin.CLASSNAME );
        initComponents();
        fBuf = new StringBuffer();
        createMenus();
        plugin.setMenuFrame( this );
    } //************************************************************************
    /** Creates menus */
    private void createMenus() {
// read config file
        FunctionList fns = new FunctionList();
// create panels
        javax.swing.JScrollPane sp = null;
        javax.swing.JPanel pnl;
        javax.swing.JCheckBox box;
        javax.swing.JButton btn;
        int i, j;
        boolean data;
        FunctionList.Function [] l;
        String [] cats = fns.getCategories();
        for( i = 0; i < cats.length; i++ ) {
            pnl = new javax.swing.JPanel();
            pnl.setLayout( new javax.swing.BoxLayout( pnl, javax.swing.BoxLayout.Y_AXIS ) );
            pnl.setName( cats[ i ] );
            l = fns.get( cats[ i ] );
// check for non-data functions
            data = true;
            for( j = 0; j < l.length; j++ )
                if( ! l[j].fData ) {
                    data = false;
                    break;
                }
            if( ! data ) { // add select/deselect buttons
                btn = new javax.swing.JButton( "Select All" );
                btn.addActionListener( new java.awt.event.ActionListener() {
                    public void actionPerformed( java.awt.event.ActionEvent evt ) {
                        selectAllButtonPressed( evt, true );
                    }
                } );
                btn.setMnemonic( java.awt.event.KeyEvent.VK_A );
                pnl.add( btn );
                btn = new javax.swing.JButton( "Deselect All" );
                btn.addActionListener( new java.awt.event.ActionListener() {
                    public void actionPerformed( java.awt.event.ActionEvent evt ) {
                        selectAllButtonPressed( evt, false );
                    }
                } );
                btn.setMnemonic( java.awt.event.KeyEvent.VK_D );
                pnl.add( btn );
            }
            for( j = 0; j < l.length; j++ ) {

                if( l[ j ].fData ) {
                    btn = new javax.swing.JButton( l[ j ].getLabel() );
                    btn.setToolTipText( l[ j ].fDescr );
                    btn.addActionListener( new java.awt.event.ActionListener() {
                        public void actionPerformed( java.awt.event.ActionEvent evt ) {
                            dataFuncButtonPressed( evt );
                        }
                    } );
                    pnl.add( btn );
                }
                else {

                    box = new javax.swing.JCheckBox( l[ j ].getLabel() );
                    if( l[ j ].fSel ) box.setSelected( true );
                    box.setToolTipText( l[ j ].fDescr );
                    box.addItemListener( new java.awt.event.ItemListener() {
                        public void itemStateChanged( java.awt.event.ItemEvent evt ) {
                            checkBoxStateChanged( evt );
                        }
                    } );
                    pnl.add( box );
                }
            } // endfor j
            sp = new javax.swing.JScrollPane();
            sp.setViewportView( pnl );
            jTabbedPane1.addTab( cats[ i ], sp );
        } // endfor i
        // cleanup
        l = null;
        cats = null;
        fns.clear();
        fns = null;
    } //************************************************************************
    /** Creates menus */
/*
    private void createMenus_old() {
        String tmp = plugin.getProperty( StarValidatorPlugin.KEY_FUNC_COUNT, true );
        if( tmp == null ) return;
        int i, j;
        boolean found;
        String cat;
        int catidx = -1;
        int pos = -1;
        int numfuncs = Integer.parseInt( tmp );
        java.util.List cats = new java.util.ArrayList();
        java.util.List funcs = new java.util.ArrayList();
        java.util.List selected = new java.util.ArrayList();
        // read properties
        for( i = 0; i < numfuncs; i++ ) {
            fBuf.setLength( 0 );
            fBuf.append( StarValidatorPlugin.KEY_FUNC_CAT );
            fBuf.append( i );
            cat = plugin.getProperty( fBuf.toString(), false );
            if( cat != null ) {
                found = false;
                for( j = 0; j < cats.size(); j++ )
                    if( cat.equals( cats.get( j ) ) ) {
                        found = true;
                        catidx = j;
                        break;
                    }
                if( ! found ) {
                    catidx = cats.size();
                    cats.add( cat );
                    funcs.add( new java.util.ArrayList() );
                }
            }
            fBuf.setLength( 0 );
            fBuf.append( StarValidatorPlugin.KEY_FUNC_NAME );
            fBuf.append( i );
            tmp = plugin.getProperty( fBuf.toString(), false );
            if( tmp != null ) {
                fBuf.setLength( 0 );
                fBuf.append( Integer.toString( i ) );
                fBuf.append( ": " );
                fBuf.append( tmp );
                ((java.util.ArrayList) funcs.get( catidx )).add( fBuf.toString() );
            }
        } // ednfor
        tmp = plugin.getProperty( StarValidatorPlugin.KEY_SELECTED, false );
        if( DEBUG ) System.err.println( "Selected: " + tmp );
        if( tmp != null ) {
            java.util.StringTokenizer stk = new java.util.StringTokenizer( tmp );
            while( stk.hasMoreTokens() ) selected.add( stk.nextToken() );
        }
        if( DEBUG ) for( i = 0; i < selected.size(); i++ ) System.err.println( selected.get( i ) );
        // create panels
        javax.swing.JScrollPane sp = null;
        javax.swing.JPanel pnl;
        javax.swing.JCheckBox box;
        javax.swing.JButton btn;
        java.util.List l;
        for( i = 0; i < cats.size(); i++ ) {
            l = (java.util.List) funcs.get( i );
            if( l.size() < 1 ) continue;
            pnl = new javax.swing.JPanel();
            pnl.setLayout( new javax.swing.BoxLayout( pnl, javax.swing.BoxLayout.Y_AXIS ) );
            btn = new javax.swing.JButton( "Select All" );
            btn.addActionListener( new java.awt.event.ActionListener() {
                public void actionPerformed( java.awt.event.ActionEvent evt ) {
                    selectAllButtonPressed( evt, true );
                }
            } );
            btn.setMnemonic( java.awt.event.KeyEvent.VK_A );
            pnl.add( btn );
            btn = new javax.swing.JButton( "Deselect All" );
            btn.addActionListener( new java.awt.event.ActionListener() {
                public void actionPerformed( java.awt.event.ActionEvent evt ) {
                    selectAllButtonPressed( evt, false );
                }
            } );
            btn.setMnemonic( java.awt.event.KeyEvent.VK_D );
            pnl.add( btn );
            pnl.setName( (String) cats.get( i ) );
            for( j = 0; j < l.size(); j++ ) {
                tmp = (String) l.get( j );
                box = new javax.swing.JCheckBox( tmp );
                pos = tmp.indexOf( ':' );
                if( pos >= 0 ) {
                    for( int k = 0; k < selected.size(); k++ )
                        if( tmp.substring( 0, pos ).equals( selected.get( k ) ) ) {
                            box.setSelected( true );
                            break;
                        }
                    fBuf.setLength( 0 );
                    fBuf.append( StarValidatorPlugin.KEY_FUNC_TIP );
                    fBuf.append( Integer.parseInt( tmp.substring( 0, pos ) ) );
                    tmp = plugin.getProperty( fBuf.toString(), false );
                    if( tmp == null ) box.setToolTipText( "" );
                    else box.setToolTipText( tmp );
                }
                else box.setToolTipText( "" );
                box.addItemListener( new java.awt.event.ItemListener() {
                    public void itemStateChanged( java.awt.event.ItemEvent evt ) {
                        checkBoxStateChanged( evt );
                    }
                } );
                pnl.add( box );
            } // endfor j
            sp = new javax.swing.JScrollPane();
            sp.setViewportView( pnl );
            jTabbedPane1.addTab( (String) cats.get( i ), sp );
        } // endfor i
        // cleanup
        for( i = 0; i < cats.size(); i++ ) {
            ((java.util.List) funcs.get( i )).clear();
        }
        cats.clear();
        funcs.clear();
    } //************************************************************************
 */
    /** Selects/deselects all functions in a category.
     * @param evt event
     * @param state selected state
     */
    private void selectAllButtonPressed( java.awt.event.ActionEvent evt, boolean state ) {
        javax.swing.JPanel tab = (javax.swing.JPanel) ((javax.swing.JButton) evt.getSource()).getParent();
        for( int i = 0; i < tab.getComponents().length; i++ )
            if( tab.getComponent( i ) instanceof javax.swing.JCheckBox )
                ((javax.swing.JCheckBox) tab.getComponent( i )).setSelected( state );
        if( DEBUG ) {
            getSelections();
            System.err.println( "sort " + getSortFlag() );
        }
    } //************************************************************************
    /** Selects/deselects all functions in a category.
     * @param evt event
     */
    private void dataFuncButtonPressed( java.awt.event.ActionEvent evt ) {
        String tmp = ((javax.swing.JButton) evt.getSource()).getText();
        int pos = tmp.indexOf( ':' );
        tmp = tmp.substring( 0, pos );
if( DEBUG ) System.err.println( "Button pressed: " + tmp + " ( " + ((javax.swing.JButton) evt.getSource()).getText() + " )" );
        pos = Integer.parseInt( tmp.trim() );
        if( pos == EDU.bmrb.validator.functions.InsertDatumCount.NUMBER )
            plugin.insertDatumCount();
        else plugin.validateData( pos );
    } //************************************************************************
    /** Selects/deselects a function */
    private void checkBoxStateChanged( java.awt.event.ItemEvent evt ) {
        //        javax.swing.JCheckBox box = (javax.swing.JCheckBox) evt.getSource();
    } //************************************************************************
    /** Handles EditBus message.
     * Does nothing.
     */
    public void handleMessage(org.gjt.sp.jedit.EBMessage eBMessage) {
    } //************************************************************************
    /** Returns selected function numbers.
     * @return array of function numbers or null
     */
    public int [] getSelections() {
        javax.swing.JScrollPane sp;
        javax.swing.JPanel tab;
        javax.swing.JCheckBox box;
        String tmp;
        int i, pos;
        java.util.List sel = new java.util.ArrayList();
        for( i = 0; i < jTabbedPane1.getTabCount(); i ++ ) {
            sp = (javax.swing.JScrollPane) jTabbedPane1.getComponent( i );
            tab = (javax.swing.JPanel) sp.getViewport().getView();
            for( int j = 0; j < tab.getComponents().length; j++ )
                if( tab.getComponent( j ) instanceof javax.swing.JCheckBox ) {
                    box = (javax.swing.JCheckBox) tab.getComponent( j );
                    if( box.isSelected() ) {
                        tmp = box.getText();
                        pos = tmp.indexOf( ':' );
                        tmp = tmp.substring( 0, pos );
                        sel.add( tmp.trim() );
                    }
                }
        }
        int [] rc = null;
        if( sel.size() > 0 ) {
            rc = new int[sel.size()];
            for( i = 0; i < rc.length; i++ )
                rc[i] = Integer.parseInt( (String) sel.get( i ) );
        }
        sel.clear();
        return rc;
    } //************************************************************************
    /** Returns true if "sort tags" is selected.
     * @return true or false
     */
    public boolean getSortFlag() {
        javax.swing.JScrollPane sp;
        javax.swing.JPanel tab;
        javax.swing.JCheckBox box;
        String tmp;
        int pos, num;
        for( int i = 0; i < jTabbedPane1.getTabCount(); i ++ ) {
            sp = (javax.swing.JScrollPane) jTabbedPane1.getComponent( i );
            tab = (javax.swing.JPanel) sp.getViewport().getView();
            for( int j = 0; j < tab.getComponents().length; j++ )
                if( tab.getComponent( j ) instanceof javax.swing.JCheckBox ) {
                    box = (javax.swing.JCheckBox) tab.getComponent( j );
                    if( box.isSelected() ) {
                        tmp = box.getText();
                        pos = tmp.indexOf( ':' );
                        tmp = tmp.substring( 0, pos );
                        num = Integer.parseInt( tmp );
                        if( num == StarValidatorPlugin.SORT_FUNC_NUM ) return true;
                    }
                }
        }
        return false;
    } //************************************************************************
    /** Returns true if "reindex rows" is selected.
     * @return true or false
     */
    public boolean getReindexFlag() {
        javax.swing.JScrollPane sp;
        javax.swing.JPanel tab;
        javax.swing.JCheckBox box;
        String tmp;
        int pos, num;
        for( int i = 0; i < jTabbedPane1.getTabCount(); i ++ ) {
            sp = (javax.swing.JScrollPane) jTabbedPane1.getComponent( i );
            tab = (javax.swing.JPanel) sp.getViewport().getView();
            for( int j = 0; j < tab.getComponents().length; j++ )
                if( tab.getComponent( j ) instanceof javax.swing.JCheckBox ) {
                    box = (javax.swing.JCheckBox) tab.getComponent( j );
                    if( box.isSelected() ) {
                        tmp = box.getText();
                        pos = tmp.indexOf( ':' );
                        tmp = tmp.substring( 0, pos );
                        num = Integer.parseInt( tmp );
                        if( num == StarValidatorPlugin.REINDEX_FUNC_NUM ) return true;
                    }
                }
        }
        return false;
    } //************************************************************************
    /** Selects/deselects all functions.
     * @param state new selected state
     */
    public void setStateAll( boolean state ) {
        javax.swing.JScrollPane sp;
        javax.swing.JPanel tab;
        javax.swing.JCheckBox box;
        String tmp;
        int pos, num;
        for( int i = 0; i < jTabbedPane1.getTabCount(); i ++ ) {
            sp = (javax.swing.JScrollPane) jTabbedPane1.getComponent( i );
            tab = (javax.swing.JPanel) sp.getViewport().getView();
            for( int j = 0; j < tab.getComponents().length; j++ )
                if( tab.getComponent( j ) instanceof javax.swing.JCheckBox )
                    ((javax.swing.JCheckBox) tab.getComponent( j )).setSelected( state );
        }
    } //************************************************************************
    /** Selects all functions */
    public void selectAll() {
        setStateAll( true );
    } //************************************************************************
    /** Unselects all functions */
    public void unselectAll() {
        setStateAll( false );
    } //************************************************************************
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jTabbedPane1 = new javax.swing.JTabbedPane();

        setLayout(new java.awt.BorderLayout());

        add(jTabbedPane1, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
    
}
