/*
 * MessageReader.java
 *
 * Created on June 30, 2004, 4:20 PM
 *
 * This software is copyright (c) 2004 Board of Regents, University of Wisconsin.
 * All Rights Reserved.
 *
 * FILE:        $Source: /cvs_archive/cvs/validator/plugin/MessageReader.java,v $
 * 
 * AUTHOR:      $Author: dmaziuk $
 * DATE:        $Date: 2004/10/05 21:20:31 $
 * 
 * UPDATE HISTORY:
 * ---------------
 * $Log: MessageReader.java,v $
 * Revision 1.1  2004/10/05 21:20:31  dmaziuk
 * added plugin
 * */

/**
 *
 * @author  dmaziuk
 */
public class MessageReader extends Thread {
    /** input stream reader */
    private java.io.BufferedReader fIn = null;
    /** error window */
    private javax.swing.JTextArea fWin = null;
    /** append flag */
    boolean fAppend = false;
//******************************************************************************
    /** Creates a new instance of MessageReader.
     * @param in input stream
     * @param win message window
     * @param append if false, overwrite existing messages
     */
    public MessageReader( java.io.InputStream in, javax.swing.JTextArea win,
    boolean append ) {
        fIn = new java.io.BufferedReader( new java.io.InputStreamReader( in ) );
        fWin = win;
        fAppend = append;
    } //************************************************************************
    /** Main method */
    public void run() {
        try {
//System.err.println( "Message thread running" );
            if( ! fAppend ) fWin.setText( "" );
            String s;
            while( (s = fIn.readLine()) != null ) {
                fWin.append( s );
                fWin.append( "\n" );
            }
            try { fIn.close(); }
            catch( java.io.IOException e ) { /* already closed? */ }
            fIn = null;
//System.err.println( "Message thread done" );
        }
        catch( java.io.IOException ex ) {
            System.err.println( ex.getMessage() );
            ex.printStackTrace();
        }
    } //************************************************************************
} //****************************************************************************
