/*
 * StarValidatorPlugin.java
 *
 * Created on June 22, 2004, 2:31 PM
 *
 * This software is copyright (c) 2004 Board of Regents, University of Wisconsin.
 * All Rights Reserved.
 *
 * FILE:        $Source: /cvs_archive/cvs/validator/plugin/StarValidatorPlugin.java,v $
 * 
 * AUTHOR:      $Author: dmaziuk $
 * DATE:        $Date: 2005/06/10 20:59:32 $
 * 
 * UPDATE HISTORY:
 * ---------------
 * $Log: StarValidatorPlugin.java,v $
 * Revision 1.12  2005/06/10 20:59:32  dmaziuk
 * refactoring
 *
 * Revision 1.11  2005/06/06 20:26:43  dmaziuk
 * Removed UI distinction between "data" and "metadata" validation functions
 *
 * Revision 1.10  2005/04/15 17:22:20  dmaziuk
 * reorganizing
 *
 * Revision 1.9  2005/03/18 21:16:26  dmaziuk
 * Added new function: InsertDatumCount
 *
 * Revision 1.8  2005/02/14 23:05:45  dmaziuk
 * FixFramecodes now replaces spaces with underscores in values
 *
 * Revision 1.7  2004/12/01 00:23:07  dmaziuk
 * Added data validation functions.
 *
 * Revision 1.6  2004/11/30 21:37:32  dmaziuk
 * added new class
 *
 * Revision 1.5  2004/11/06 00:01:57  dmaziuk
 * *** empty log message ***
 *
 * Revision 1.4  2004/10/27 19:37:50  dmaziuk
 * changed menu gui
 *
 * Revision 1.3  2004/10/21 21:01:29  dmaziuk
 * Bugfix: delete old error messages properly
 *
 * Revision 1.2  2004/10/19 23:30:18  dmaziuk
 * *** empty log message ***
 *
 * Revision 1.1  2004/10/05 21:20:31  dmaziuk
 * added plugin
 * */

/**
 * 
 * @author  dmaziuk
 */
public class StarValidatorPlugin //extends org.gjt.sp.jedit.EditPlugin {
                                 extends org.gjt.sp.jedit.EBPlugin {
    private static final boolean DEBUG = false;
    /** handleMessage method receives notifications of "major" buffer state
     * changes. We need to track changes to buffer content, to decide if we
     * need to re-load the database before validation/unparse. This listener
     * class does that.
     */
    private class ChangeListener extends org.gjt.sp.jedit.buffer.BufferChangeAdapter {
        /** Called when text is inserted into the buffer.
         * Sets "dirty" flag to true: signals validator to reload the entry into DB.
         * @param buf buffer
         * @param startLine first line
         * @param offset ofset form beginning of the buffer
         * @param numlines number of lines inserted
         * @param length number of characters inserted
         */
        public void contentInserted( org.gjt.sp.jedit.Buffer buf, int startLine,
        int offset, int numlines, int length ) {
//System.err.println( "Got buffer insert" );
            fDirty = true;
if( DEBUG ) System.err.println( "Buffer is dirty" );
        } //********************************************************************
        /** Called when text is deleted from the buffer.
         * Sets "dirty" flag to true: signals validator to reload the entry into DB.
         * @param buf buffer
         * @param startLine first line
         * @param offset ofset form beginning of the buffer
         * @param numlines number of lines deleted
         * @param length number of characters deleted
         */
        public void contentRemoved( org.gjt.sp.jedit.Buffer buf, int startLine,
        int offset, int numlines, int length ) {
//System.err.println( "Got buffer delete" );
            fDirty = true;
if( DEBUG ) System.err.println( "Buffer is dirty" );
        } //********************************************************************
        /** Called after compound edits such as undo ro replace all.
         * Sets "dirty" flag to true: signals validator to reload the entry into DB.
         * @param buf buffer
         */
        public void transactionComplete( org.gjt.sp.jedit.Buffer buf ) {
//System.err.println( "Got buffer transaction complete" );
            fDirty = true;
if( DEBUG ) System.err.println( "Buffer is dirty" );
        } //********************************************************************
    } //************************************************************************
    /** plugin name */
    public static final String NAME = "menuwin";
    /** plugin class name */
    public static final String CLASSNAME = "StarValidatorPlugin";
    /** plugin menu */
    public static final String MENU = "menuwin.menu";
    /** property prefix */
    public static final String PROPERTY_PREFIX = "plugin.StarValidatorPlugin.";
    /** option prefix */
    public static final String OPTION_PREFIX = "options.menuwin.";
    /** config file */
    public static final String DEFAULT_CONFIG_FILE = System.getProperty( "user.home" ) +
    java.io.File.separator + "validator.properties";
    /* property keys */
    /* commands */
    /** Load dictionary command */
    public static final String KEY_LOADDICT_CMD = "Loaddictionary.cmd";
    /** Load dictionary conffile switch */
    public static final String KEY_LOADDICT_CONF = "Loaddictionary.switch.conffile";
    /** Load dictionary infile switch */
    public static final String KEY_LOADDICT_INF = "Loaddictionary.switch.infile";
    /** Load referrence data command */
    public static final String KEY_LOADREF_CMD = "Loadrefdata.cmd";
    /** Load reference data conffile switch */
    public static final String KEY_LOADREF_CONF = "Loadrefdata.switch.conffile";
    /** Load reference data infile switch */
    public static final String KEY_LOADREF_INF = "Loadrefdata.switch.infile";
    /** Load entry command */
    public static final String KEY_LOAD_CMD = "Load.cmd";
    /** Load entry conffile switch */
    public static final String KEY_LOAD_CONF = "Load.switch.conffile";
    /** Check syntax command */
    public static final String KEY_SYNTAX_CMD = "Syntaxcheck.cmd";
    /** Validate command */
    public static final String KEY_VALIDATE_CMD = "Validate.cmd";
    /** Validate conffile switch */
    public static final String KEY_VALIDATE_CONF = "Validate.switch.conffile";
    /** Validate function switch */
    public static final String KEY_VALIDATE_FUNC = "Validate.switch.func";
    /** Validate data function switch */
    public static final String KEY_VALIDATE_DATAFUNC = "Validate.switch.datafunc";
    /** Validate edit switch */
    public static final String KEY_VALIDATE_EDIT = "Validate.switch.edit";
    /** Validate load switch */
    public static final String KEY_VALIDATE_NOLOAD = "Validate.switch.noload";
    /** Validate input file switch */
    public static final String KEY_VALIDATE_INFILE = "Validate.switch.infile";
    /** InsertDatumCount command */
    public static final String KEY_DATUM_CMD = "Datumcount.cmd";
    /** InsertDatumCount conffile switch */
    public static final String KEY_DATUM_CONF = "Datumcount.switch.conffile";
    /** Unparse command */
    public static final String KEY_UNPARSE_CMD = "Unparse.cmd";
    /** Unparse conffile switch */
    public static final String KEY_UNPARSE_CONF = "Unparse.switch.conffile";
    /** Unparse reindex switch */
    public static final String KEY_UNPARSE_REINDEX = "Unparse.switch.reindex";
    /** Unparse sort switch */
    public static final String KEY_UNPARSE_SORT = "Unparse.switch.sort";
    /** Unparse outfile switch */
    public static final String KEY_UNPARSE_OUTF = "Unparse.switch.outfile";
    /** Insert saveframe command */
    public static final String KEY_INSSF_CMD = "Insertsaveframe.cmd";
    /** Insert saveframe conffile switch */
    public static final String KEY_INSSF_CONF = "Insertsaveframe.switch.conffile";
    /** Insert saveframe list categories switch */
    public static final String KEY_INSSF_LIST = "Insertsaveframe.switch.list";
    /** Insert saveframe sf category switch */
    public static final String KEY_INSSF_CAT = "Insertsaveframe.switch.sfcat";
    /* functions */
    /** number of functions */
    public static final String KEY_FUNC_COUNT = "Validator.func.count";
    /** function category */
    public static final String KEY_FUNC_CAT = "Validator.func.category";
    /** function name */
    public static final String KEY_FUNC_NAME = "Validator.func.name";
    /** function description */
    public static final String KEY_FUNC_TIP = "Validator.func.description";
    /** data function flag */
    public static final String KEY_FUNC_DATA = "Validator.func.data";
    /* labels */
    /** Select label */
    public static final String KEY_SEL_LABEL = "Validator.action.select.name";
    /** Select tip */
    public static final String KEY_SEL_TIP = "Validator.action.select.tip";
    //
    /** Directory of dictionary files */
    public static final String KEY_DICT_DIR = "Validator.dictdir";
    /** Pre-selected functions */
    public static final String KEY_SELECTED = "Validator.functions";
    //
    /** Reindex rows function number */
    public static final int REINDEX_FUNC_NUM = 85;
    /** Sort tags function number */
    public static final int SORT_FUNC_NUM = 80;
    //
    /** listener for buffer change */
    private ChangeListener fListener = null;
    /** error window */
    private ErrorWindow fErrWin = null;
    /** menu window */
    private MenuFrame fMenuFrame = null;
    /** true when buffer is changed */
    private boolean fDirty = true;
    /** config */
    private java.util.Properties fProps = null;
    /** string buffer */
    private StringBuffer fBuf = null;
    /** NMR-STAR filename */
    private String fEntry = null;
    /** NMR-STAR file path */
    private String fEntryPath = null;
    /** config file */
    private String CONFIG_FILE = null;
//******************************************************************************
    /** Creates a new instance of TestPlugin */
    public StarValidatorPlugin() {
        fListener = new ChangeListener();
        fBuf = new StringBuffer();
    } //************************************************************************
    /** Creates menu.
     * Creates Plugins - Validator menu. Menu items are deifned in acions.xml
     * and in properties file.
     * @param items menu items
     */
    public void createMenuItems( java.util.Vector items ) {
        items.addElement( org.gjt.sp.jedit.GUIUtilities.loadMenu( MENU ) );
    } //************************************************************************
    /** Handles EditBus message.
     * Cannot do this in constructor because there may be no open buffer(s) at
     * that point.
     * @param msg message
     */
    public void handleMessage( org.gjt.sp.jedit.EBMessage msg ) {
        if( msg instanceof org.gjt.sp.jedit.msg.BufferUpdate ) {
            if( ((org.gjt.sp.jedit.msg.BufferUpdate) msg).getWhat() == org.gjt.sp.jedit.msg.BufferUpdate.LOADED ) {
//System.err.println( "buffer LOADED" );
                fDirty = true;
                if( org.gjt.sp.jedit.jEdit.getBuffers().length > 0 )
                    org.gjt.sp.jedit.jEdit.getBuffers()[0].addBufferChangeListener( fListener );
//System.err.println( "Added listener" );
            }
            if( ((org.gjt.sp.jedit.msg.BufferUpdate) msg).getWhat() == org.gjt.sp.jedit.msg.BufferUpdate.CREATED ) {
                fDirty = true;
                if( org.gjt.sp.jedit.jEdit.getBuffers().length > 0 )
                    org.gjt.sp.jedit.jEdit.getBuffers()[0].addBufferChangeListener( fListener );
//System.err.println( "Added listener" );
//System.err.println( "buffer CREATED" );
            }
            if( ((org.gjt.sp.jedit.msg.BufferUpdate) msg).getWhat() == org.gjt.sp.jedit.msg.BufferUpdate.DIRTY_CHANGED ) {
                fDirty = true;
//System.err.println( "DIRTY_CHANGED" );
if( DEBUG ) System.err.println( "Buffer is dirty" );
            }
        }
    } //************************************************************************
    /** Plugin start-up.
     * Connect to database.
     */
    public void start() {
        try {
            if( fProps == null ) fProps = new java.util.Properties();
            String conffile = System.getProperty( "validator.config" );
            if( conffile == null ) CONFIG_FILE = DEFAULT_CONFIG_FILE;
            else CONFIG_FILE = System.getProperty( "user.home" ) + java.io.File.separator + conffile;
            java.io.InputStream in = new java.io.FileInputStream( CONFIG_FILE );
            fProps.load( in );
            in.close();
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
    } //************************************************************************
    /** Plugin shut-down.
     * Close JDBC connection.
     */
    public void stop() {
    } //************************************************************************
    /** Set up ref to error window.
     * @param win error window
     */
    public void setErrorWindow( ErrorWindow win ) {
        fErrWin = win;
    } //************************************************************************
    /** Set up ref to menu window.
     * @param win menu window
     */
    public void setMenuFrame( MenuFrame win ) {
        fMenuFrame = win;
    } //************************************************************************
    /** Returns property value.
     * @param key property key
     * @param check if true, print error message to stderr if property is missing
     * @return value or null
     */
    public String getProperty( String key, boolean check ) {
        String rc = fProps.getProperty( key );
        if( check && ((rc == null) || (rc.length() < 1)) ) {
            System.err.println( "Error in configuration file: missing " + key );
if( DEBUG ) Thread.currentThread().dumpStack();
        }
        if( (rc == null) || (rc.length() < 1) ) return null;
        return rc;
    } //************************************************************************
    /** Retunrs current NMR-STAR filename.
     * @return filename or null
     */
    public String getEntryFilename() {
        return fEntry;
    } //************************************************************************
    /** Retunrs current NMR-STAR file path.
     * @return filename or null
     */
    public String getEntryFilepath() {
        return fEntryPath;
    } //************************************************************************
    /** Checks if multiple files are open.
     * @return false if more than one file is open.
     */
    private boolean checkBuffers() {
        if( org.gjt.sp.jedit.jEdit.getBuffers().length != 1 ) {
            javax.swing.JOptionPane.showMessageDialog( 
            org.gjt.sp.jedit.jEdit.getActiveView(), "More than one file open!",
            "Error", javax.swing.JOptionPane.ERROR_MESSAGE );
            return false;
	}
	return true;
    } //************************************************************************
    /** Checks if validator windows are open.
     * jEdit creates objects when first opening the window. If conrtol or error
     * windows have not been opened, corresp. objects are nulls and we get a
     * null pointer exception.
     * @return false if windows are closed
     */
    private boolean checkWindows() {
        if( fMenuFrame == null ) {
            javax.swing.JOptionPane.showMessageDialog( 
            org.gjt.sp.jedit.jEdit.getActiveView(), "Open validator window first",
            "Error", javax.swing.JOptionPane.ERROR_MESSAGE );
            return false;
        }
        if( fErrWin == null ) {
            javax.swing.JOptionPane.showMessageDialog( 
            org.gjt.sp.jedit.jEdit.getActiveView(), "Open validation errors window first",
            "Error", javax.swing.JOptionPane.ERROR_MESSAGE );
            return false;
        }
        return true;
    } //************************************************************************
    /** Shows file chooser.
     * @param startdir starting directory
     * @param starfile if true, set default filter to *.str, else -- to *.*
     * @param save if true, show save dialog, else show open dialog
     * @return selected fiel or null
     */
    private java.io.File chooseFile( String startdir, boolean starfile, boolean save ) {
        javax.swing.JFileChooser fc = new javax.swing.JFileChooser();
        if( starfile ) fc.setFileFilter( new EDU.bmrb.validator.swing.StarFileFilter() );
        try {
            fc.setCurrentDirectory( new java.io.File( startdir ) );
        }
        catch( Exception e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        fc.setBounds( 30, 60, 500, 326 );
        int rc;
        if( save ) rc = fc.showSaveDialog( fMenuFrame );
        else rc = fc.showOpenDialog( fMenuFrame );
        if( rc == javax.swing.JFileChooser.APPROVE_OPTION ) return fc.getSelectedFile();
        else return null;
    } //************************************************************************
    /** Selects all functions. */
    public void selectAll() {
        if( ! checkWindows() ) return;
        fMenuFrame.selectAll();
//        fMenuWin.selectAll();
    } //************************************************************************    
    /** Unselects all functions. */
    public void unselectAll() {
        if( ! checkWindows() ) return;
        fMenuFrame.unselectAll();
//        fMenuWin.unselectAll();
    } //************************************************************************    
    /** Loads validation dictionary. */
    public void loadDictionary() {
        if( ! checkWindows() ) return;
        if( getProperty( KEY_LOADDICT_CMD, true ) == null ) return;
        if( getProperty( KEY_LOADDICT_CONF, true ) == null ) return;
        if( getProperty( KEY_LOADDICT_INF, true ) == null ) return;
        fBuf.setLength( 0 );
        fBuf.append( getProperty( KEY_LOADDICT_CMD, false ) );
        fBuf.append( ' ' );
        fBuf.append( getProperty( KEY_LOADDICT_CONF, false ) );
        fBuf.append( ' ' );
        fBuf.append( CONFIG_FILE );
        fBuf.append( ' ' );
// if property is missing, chooser should start in current directory
        java.io.File f = chooseFile( getProperty( KEY_DICT_DIR, false ), true, false );
        if( f == null ) return;
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_LOADDICT_INF, false ) );
            fBuf.append( ' ' );
            fBuf.append( f.getCanonicalPath() );
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
            fErrWin.clear();
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
            
//            new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false ).start();
//            fErrWin.showMessages( p.getInputStream() );
            
            fBuf.setLength( 0 );
//FIXME
            fDirty = true;
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException ex ) {
            System.err.println( ex.getMessage() );
            ex.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    public void loadRefInfo() {
        if( ! checkWindows() ) return;
        if( getProperty( KEY_LOADREF_CMD, true ) == null ) return;
        if( getProperty( KEY_LOADREF_CONF, true ) == null ) return;
        if( getProperty( KEY_LOADREF_INF, true ) == null ) return;
        fBuf.setLength( 0 );
        fBuf.append( getProperty( KEY_LOADREF_CMD, false ) );
        fBuf.append( ' ' );
        fBuf.append( getProperty( KEY_LOADREF_CONF, false ) );
        fBuf.append( ' ' );
        fBuf.append( CONFIG_FILE );
        fBuf.append( ' ' );
// if property is missing, chooser should start in current directory
        java.io.File f = chooseFile( getProperty( KEY_DICT_DIR, false ), true, false );
        if( f == null ) return;
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_LOADREF_INF, false ) );
            fBuf.append( ' ' );
            fBuf.append( f.getCanonicalPath() );
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
            fErrWin.clear();
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
            
//            new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false ).start();
//            fErrWin.showMessages( p.getInputStream() );
            
            fBuf.setLength( 0 );
//FIXME
            fDirty = true;
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException ex ) {
            System.err.println( ex.getMessage() );
            ex.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Runs syntax checker */
    public void checkSyntax() {
        if( ! checkWindows() ) return;
	if( ! checkBuffers() ) return;
        if( getProperty( KEY_SYNTAX_CMD, true ) == null ) return;
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
System.err.println( "Running " + getProperty( KEY_SYNTAX_CMD, false ) );
            Process p = Runtime.getRuntime().exec( getProperty( KEY_SYNTAX_CMD, false ) );
            new ErrorReader( p.getErrorStream() ).start();
//            new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false ).start();
            org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
            java.io.OutputStream out = p.getOutputStream();
            try { out.write( buf.getText( 0, buf.getLength() ).getBytes() ); }
            catch( java.io.IOException ex ) {
                if( ! ex.getMessage().equals( "Broken pipe" ) ) throw ex;
                System.err.print( ex.getMessage() );
                System.err.println( ": parse error?" );
            }
            out.close();
            fErrWin.clear();
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException ex ) {
            System.err.println( ex.getMessage() );
            ex.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }	
    } //************************************************************************
    /** Runs validation functions */
    public void validate() {
        if( ! checkWindows() ) return;
	if( ! checkBuffers() ) return;
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
//FIXME
if( DEBUG ) System.err.println( "Deleting old errors" );
            fErrWin.clear();
// load enrty
            if( fDirty ) {
                if( ! load() ) return;
            }
// validate
            if( getProperty( KEY_VALIDATE_CMD, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_CONF, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_FUNC, true ) == null ) return;
            fBuf.setLength( 0 );
            fBuf.append( getProperty( KEY_VALIDATE_CMD, false ) );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_VALIDATE_CONF, false ) );
            fBuf.append( ' ' );
            fBuf.append( CONFIG_FILE );
            int selected [] = fMenuFrame.getSelections();
//            int selected [] = fMenuWin.getSelections();
            if( selected != null )
                for( int i = 0; i < selected.length; i++ ) {
                    fBuf.append( ' ' );
                    fBuf.append( getProperty( KEY_VALIDATE_FUNC,  false ) );
                    fBuf.append( ' ' );
                    fBuf.append( selected[i] );
                }
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
/*
            MessageReader mr = new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false );
            mr.start();
            p.waitFor();
            while( mr.isAlive() ) {
                Thread.currentThread().sleep( 10 );
//System.err.println( "Waiting" );
            }
 */
            fErrWin.add( "\nValidator:" );
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
            fBuf.setLength( 0 );
//            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Runs editing functions. */
    public void edit() {
        if( ! checkWindows() ) return;
	if( ! checkBuffers() ) return;
// ask to save current buffer [under different name]
//FIXME
        if( ! saveBak() ) return;
        org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
//        if( ! buf.saveAs( org.gjt.sp.jedit.jEdit.getActiveView(), false ) ) return;
        String filename = buf.getPath();
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
//FIXME
if( DEBUG ) System.err.println( "Deleting old errors" );
            fErrWin.clear();
// load enrty
            if( fDirty ) {
                if( ! load() ) return;
                fDirty = false;
            }
// edit
            if( getProperty( KEY_VALIDATE_CMD, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_CONF, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_FUNC, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_EDIT, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_INFILE, true ) == null ) return;
            fBuf.setLength( 0 );
            fBuf.append( getProperty( KEY_VALIDATE_CMD, false ) );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_VALIDATE_CONF, false ) );
            fBuf.append( ' ' );
            fBuf.append( CONFIG_FILE );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_VALIDATE_EDIT, false ) );
            fBuf.append( ' ' );
	    if( ! fDirty ) {
                fBuf.append( getProperty( KEY_VALIDATE_NOLOAD,  false ) );
                fBuf.append( ' ' );
	    }
            fBuf.append( getProperty( KEY_VALIDATE_INFILE, false ) );
            fBuf.append( ' ' );
            fBuf.append( buf.getPath() );
            fBuf.append( ' ' );
            int selected [] = fMenuFrame.getSelections();
//            int selected [] = fMenuWin.getSelections();
            if( selected != null )
                for( int i = 0; i < selected.length; i++ ) {
                    fBuf.append( ' ' );
                    fBuf.append( getProperty( KEY_VALIDATE_FUNC,  false ) );
                    fBuf.append( ' ' );
                    fBuf.append( selected[i] );
                }
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
//            new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false ).start();
            fErrWin.add( "\nValidator:" );
            fErrWin.addMessages( p.getInputStream() );        
            p.waitFor();
// unparse
            unparse( filename );
            fDirty = true;
        }
        catch( InterruptedException ei ) { /* ignore it for now */ }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Inserts a saveframe. */
    public void insertSaveFrame() {
        if( ! checkWindows() ) return;
	if( ! checkBuffers() ) return;
// ask to save current buffer [under different name]
//FIXME
        org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
//        if( ! buf.saveAs( org.gjt.sp.jedit.jEdit.getActiveView(), false ) ) return;
        if( ! saveBak() ) return;
        String filename = buf.getPath();
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
// load enrty
//FIXME
if( DEBUG ) System.err.println( "Deleting old errors" );
            fErrWin.clear();
            if( fDirty ) {
                if( ! load() ) return;
            }
// get saveframe category
            if( getProperty( KEY_INSSF_CMD, true ) == null ) return;
            if( getProperty( KEY_INSSF_CONF, true ) == null ) return;
            if( getProperty( KEY_INSSF_LIST, true ) == null ) return;
            if( getProperty( KEY_INSSF_CAT, true ) == null ) return;
            fBuf.setLength( 0 );
            fBuf.append( getProperty( KEY_INSSF_CMD, false ) );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_INSSF_CONF, false ) );
            fBuf.append( ' ' );
            fBuf.append( CONFIG_FILE );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_INSSF_LIST, false ) );
            java.util.List cats = new java.util.ArrayList();
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
            java.io.BufferedReader in = new java.io.BufferedReader( 
            new java.io.InputStreamReader( p.getInputStream() ) );
            String cat;
            while( (cat = in.readLine()) != null ) {
                cats.add( cat );
//System.err.println( cat );
            }
            in.close();
            String sfcat = (String) javax.swing.JOptionPane.showInputDialog(
            fMenuFrame, "Saveframe categories:", "Select saveframe category", 
            javax.swing.JOptionPane.PLAIN_MESSAGE, null, cats.toArray(), null );
            cats.clear();
            cats = null;
// insert saveframe
if( DEBUG ) System.err.println( "Selected category |" + sfcat + "|" );
            if( (sfcat != null ) && (sfcat.length() > 0) ) {
                fBuf.setLength( 0 );
                fBuf.append( getProperty( KEY_INSSF_CMD, false ) );
                fBuf.append( ' ' );
                fBuf.append( getProperty( KEY_INSSF_CONF, false ) );
                fBuf.append( ' ' );
                fBuf.append( CONFIG_FILE );
                fBuf.append( ' ' );
                fBuf.append( getProperty( KEY_INSSF_CAT, false ) );
                fBuf.append( ' ' );
                fBuf.append( sfcat );
System.err.println( "Running " + fBuf );
                p = Runtime.getRuntime().exec( fBuf.toString() );
                new ErrorReader( p.getErrorStream() ).start();
//                new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false ).start();
                fErrWin.add( "\nValidator:" );
                fErrWin.addMessages( p.getInputStream() );
                p.waitFor();
// unparse
                unparse( filename );
                fDirty = true;
            }            
        }
        catch( InterruptedException ei ) { /* ignore it for now */ }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Loads entry into database.
     * @return true if loading was successful
     * @throws java.io.IOException
     * @throws InterruptedException
     */
    public boolean load() throws java.io.IOException, InterruptedException {
        if( getProperty( KEY_LOAD_CMD, true ) == null ) return false;
        if( getProperty( KEY_LOAD_CONF, true ) == null ) return false;
        fBuf.setLength( 0 );
        fBuf.append( getProperty( KEY_LOAD_CMD, false ) );
        fBuf.append( ' ' );
        fBuf.append( getProperty( KEY_LOAD_CONF, false ) );
        fBuf.append( ' ' );
        fBuf.append( CONFIG_FILE );
System.err.println( "Running " + fBuf );
        Process p = Runtime.getRuntime().exec( fBuf.toString() );
        new ErrorReader( p.getErrorStream() ).start();
/*
        MessageReader mr = new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false );
        mr.start();
 */
        org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
        fEntry = buf.getName();
        fEntryPath = buf.getPath();
        java.io.OutputStream out = p.getOutputStream();
        try { out.write( buf.getText( 0, buf.getLength() ).getBytes() ); }
        catch( java.io.IOException ex ) {
            if( ! ex.getMessage().equals( "Broken pipe" ) ) throw ex;
            System.err.print( ex.getMessage() );
            System.err.println( ": parse error?" );
        }
        out.close();
        fErrWin.clear();
        fErrWin.add( "Parser:" );
        fErrWin.addMessages( p.getInputStream() );        
        p.waitFor();
//        while( mr.isAlive() ) Thread.currentThread().sleep( 10 );
        fDirty = false;
if( DEBUG ) System.err.println( "Buffer is clean" );
        return (p.exitValue() == 0);
    } //************************************************************************
    /** Unparse the entry.
     * @param filename name of output file
     * @throws java.io.IOException
     * @throws InterruptedException
     */
    public void unparse( String filename ) throws java.io.IOException,
    InterruptedException {
        String tmp;
        if( getProperty( KEY_UNPARSE_CMD, true ) == null ) return;
        if( getProperty( KEY_UNPARSE_CONF, true ) == null ) return;
        if( getProperty( KEY_UNPARSE_OUTF, true ) == null ) return;
        fBuf.setLength( 0 );
        fBuf.append( getProperty( KEY_UNPARSE_CMD, false ) );
        fBuf.append( ' ' );
        fBuf.append( getProperty( KEY_UNPARSE_CONF, false ) );
        fBuf.append( ' ' );
        fBuf.append( CONFIG_FILE );
        fBuf.append( ' ' );
        if( fMenuFrame.getReindexFlag() ) {
            tmp = getProperty( KEY_UNPARSE_REINDEX, true );
            if( tmp != null ) {
                fBuf.append( tmp );
                fBuf.append( ' ' );
            }
        }
// always sort
//        if( fMenuFrame.getSortFlag() ) {
            tmp = getProperty( KEY_UNPARSE_SORT, true );
            if( tmp != null ) {
                fBuf.append( tmp );
                fBuf.append( ' ' );
            }
//        }
        fBuf.append( getProperty( KEY_UNPARSE_OUTF, false ) );
        fBuf.append( ' ' );
        fBuf.append( filename );
System.err.println( "Running " + fBuf );
        Process p = Runtime.getRuntime().exec( fBuf.toString() );
        new ErrorReader( p.getErrorStream() ).start();

// use with UnparseEntry
        org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
        java.io.OutputStream out = p.getOutputStream();
	String msg = null;
        try { out.write( buf.getText( 0, buf.getLength() ).getBytes() ); }
        catch( java.io.IOException ex ) {
            if( ! ex.getMessage().equals( "Broken pipe" ) ) throw ex;
            System.err.print( ex.getMessage() );
            System.err.println( ": parse error?" );
	    msg = ex.getMessage();
        }
        out.close();
// use with UnparseEntry
        
        fErrWin.add( "\nUnparser:" );
        fErrWin.addMessages( p.getInputStream() );        
//        new MessageReader( p.getInputStream(), fErrWin.getTextArea(), false ).start();
        p.waitFor();
//System.err.println( "Reload" );
//FIXME
        if( msg != null ) fErrWin.add( "FATAL ERROR: unparser exception. File was not modified (" + msg +")" );
        buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
        org.gjt.sp.jedit.io.VFSManager.waitForRequests();
        buf.load( org.gjt.sp.jedit.jEdit.getActiveView(), true );
        fDirty = true;
if( DEBUG ) System.err.println( "Buffer is dirty" );
    } //************************************************************************
    /** Runs data validation function
     * @param num function number
     */
    public void validateData( int num ) {
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
//FIXME
if( DEBUG ) System.err.println( "Deleting old errors" );
            fErrWin.clear();
// load enrty
            if( fDirty ) {
                if( ! load() ) return;
            }
// validate
            if( getProperty( KEY_VALIDATE_CMD, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_CONF, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_DATAFUNC, true ) == null ) return;
            fBuf.setLength( 0 );
            fBuf.append( getProperty( KEY_VALIDATE_CMD, false ) );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_VALIDATE_CONF, false ) );
            fBuf.append( ' ' );
            fBuf.append( CONFIG_FILE );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_VALIDATE_DATAFUNC,  false ) );
            fBuf.append( ' ' );
            fBuf.append( num );
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
            org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
            java.io.OutputStream out = p.getOutputStream();
            try { out.write( buf.getText( 0, buf.getLength() ).getBytes() ); }
            catch( java.io.IOException ex ) {
                if( ! ex.getMessage().equals( "Broken pipe" ) ) throw ex;
                System.err.print( ex.getMessage() );
                System.err.println( ": parse error?" );
            }
            out.close();
//System.err.println( "Waiting" );
            fErrWin.add( "\nValidator:" );
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
            fBuf.setLength( 0 );
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Runs all validation functions
     */
//
//
//
    public void validate_all() {
        try {
if( DEBUG ) System.err.println( "Dirty = " + fDirty );
            org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
            if( buf.isDirty() )
                if( ! buf.save( org.gjt.sp.jedit.jEdit.getActiveView(), null ) ) {
                    javax.swing.JOptionPane.showMessageDialog(
                    org.gjt.sp.jedit.jEdit.getActiveView(), "Cannot save file!",
                    "Error", javax.swing.JOptionPane.ERROR_MESSAGE );
                    return;
                }
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
//FIXME
if( DEBUG ) System.err.println( "Deleting old errors" );
            fErrWin.clear();
// validate
            if( getProperty( KEY_VALIDATE_CMD, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_CONF, true ) == null ) return;
            if( getProperty( KEY_VALIDATE_NOLOAD, true ) == null ) return;
            fBuf.setLength( 0 );
            fBuf.append( getProperty( KEY_VALIDATE_CMD, false ) );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_VALIDATE_CONF, false ) );
            fBuf.append( ' ' );
            fBuf.append( CONFIG_FILE );
            fBuf.append( ' ' );
	    if( ! fDirty ) {
                fBuf.append( getProperty( KEY_VALIDATE_NOLOAD,  false ) );
                fBuf.append( ' ' );
	    }
            if( getProperty( KEY_VALIDATE_INFILE, true ) == null ) return;
            fBuf.append( getProperty( KEY_VALIDATE_INFILE, false ) );
            fBuf.append( ' ' );
            fBuf.append( buf.getPath() );
	    
	    int selected [] = fMenuFrame.getSelections();
            if( selected != null )
                for( int i = 0; i < selected.length; i++ ) {
                    fBuf.append( ' ' );
                    fBuf.append( getProperty( KEY_VALIDATE_FUNC,  false ) );
                    fBuf.append( ' ' );
                    fBuf.append( selected[i] );
		}
	    else return;
	    
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
	    
//System.err.println( "Waiting" );
            fErrWin.add( "\nValidator:" );
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
            fBuf.setLength( 0 );
	    fDirty = false;
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Runs InsertDatumCount function */
    public void insertDatumCount() {
        if( ! checkWindows() ) return;
	if( ! checkBuffers() ) return;
// ask to save current buffer [under different name]
//FIXME
        org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
//        if( ! buf.saveAs( org.gjt.sp.jedit.jEdit.getActiveView(), false ) ) return;
        if( ! saveBak() ) return;
        String filename = buf.getPath();
        try {
            org.gjt.sp.jedit.jEdit.getActiveView().showWaitCursor();
//FIXME
if( DEBUG ) System.err.println( "Deleting old errors" );
            fErrWin.clear();
// load enrty
            if( fDirty ) {
                if( ! load() ) return;
            }
// validate
            if( getProperty( KEY_DATUM_CMD, true ) == null ) return;
            if( getProperty( KEY_DATUM_CONF, true ) == null ) return;
            fBuf.setLength( 0 );
            fBuf.append( getProperty( KEY_DATUM_CMD, false ) );
            fBuf.append( ' ' );
            fBuf.append( getProperty( KEY_DATUM_CONF, false ) );
            fBuf.append( ' ' );
            fBuf.append( CONFIG_FILE );
System.err.println( "Running " + fBuf );
            Process p = Runtime.getRuntime().exec( fBuf.toString() );
            new ErrorReader( p.getErrorStream() ).start();
            buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
            java.io.OutputStream out = p.getOutputStream();
            try { out.write( buf.getText( 0, buf.getLength() ).getBytes() ); }
            catch( java.io.IOException ex ) {
                if( ! ex.getMessage().equals( "Broken pipe" ) ) throw ex;
                System.err.print( ex.getMessage() );
                System.err.println( ": parse error?" );
            }
            out.close();
//System.err.println( "Waiting" );
            fErrWin.add( "\nValidator:" );
            fErrWin.addMessages( p.getInputStream() );
            p.waitFor();
// unparse
            unparse( filename );
            fDirty = true;
            fBuf.setLength( 0 );
        }
        catch( java.io.IOException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        catch( InterruptedException e ) {
            System.err.println( e.getMessage() );
            e.printStackTrace();
        }
        finally {
            org.gjt.sp.jedit.jEdit.getActiveView().hideWaitCursor();
        }
    } //************************************************************************
    /** Saves backup copy of current buffer */
    public boolean saveBak() {
if( DEBUG ) System.err.println( "saveBak()" );
        org.gjt.sp.jedit.Buffer buf = org.gjt.sp.jedit.jEdit.getBuffers()[0];
        java.io.File file = new java.io.File( buf.getPath() );
        java.io.File dir = file.getParentFile();
        final String filename = file.getName();
if( DEBUG ) System.err.println( "Dirname " + dir.getPath() );
        String [] baks = dir.list( new java.io.FilenameFilter() {
            public boolean accept( java.io.File dir, String name ) {
                if( name.indexOf( filename ) > -1 ) return true;
                return false;
            }
        } );
if( DEBUG ) for( int i = 0; i < baks.length; i++ ) System.err.println( baks[i] );
        int last = 0;
        int ver = 0;
        String ext;
        for( int i = 0; i < baks.length; i++ ) {
            if( filename.equals( baks[i] ) ) continue;
            ext = baks[i].substring( filename.length() ).replaceAll( "\\D", "" );
            if( (ext != null) && (! ext.equals( "" )) ) {
                try { ver = Integer.parseInt( ext ); }
                catch( NumberFormatException e ) { ver = 0; }
                if( ver > last ) last = ver;
            }
        }
        last++;
        String savename = buf.getPath() + "." + last;
if( DEBUG ) System.err.println( "Savename " + savename );
        if( ! buf.save( org.gjt.sp.jedit.jEdit.getActiveView(), savename, false ) ) {
            javax.swing.JOptionPane.showMessageDialog(
            org.gjt.sp.jedit.jEdit.getActiveView(), "Cannot save file" + savename + "!",
            "Error", javax.swing.JOptionPane.ERROR_MESSAGE );
            return false;
        }
        return true;
    } //************************************************************************
} //****************************************************************************
