-- 
-- Create tables for entry
--
-- Make sure size of varchars for comments is the same as size of val in entryvals
--
--
DROP SEQUENCE ESFSEQ;
COMMIT;
DROP SEQUENCE ELOOPSEQ;
COMMIT;
DROP SEQUENCE ETAGSEQ;
COMMIT;
DROP SEQUENCE EVALSEQ;
COMMIT;
DROP VIEW ENTRYMANDATORY;
COMMIT;
DROP VIEW ENTRYRESTYPES;
COMMIT;
DROP TABLE ENTRYVALS;
COMMIT;
DROP TABLE ENTRYTAGS;
COMMIT;
DROP TABLE ENTRYLOOPS;
COMMIT;
DROP TABLE ENTRYSFS;
COMMIT;
DROP TABLE ENTRYINFO;
COMMIT;
DROP TABLE DELIMENUM;

COMMIT;

CREATE TABLE DELIMENUM (
 DELIM INTEGER PRIMARY KEY,
 DESCRIPTION VARCHAR(80) );

COMMIT;

INSERT INTO DELIMENUM (DELIM, DESCRIPTION) VALUES (9, 'single quote' );
INSERT INTO DELIMENUM (DELIM, DESCRIPTION) VALUES (10, 'double quote' );
INSERT INTO DELIMENUM (DELIM, DESCRIPTION) VALUES (11, 'semicolon' );
INSERT INTO DELIMENUM (DELIM, DESCRIPTION) VALUES (12, 'framecode' );
INSERT INTO DELIMENUM (DELIM, DESCRIPTION) VALUES (13, 'none' );

COMMIT;

CREATE TABLE ENTRYINFO (
 NAME VARCHAR(127) NOT NULL,
 LINE INTEGER,
 COL INTEGER,
 PRECOMMENT VARCHAR(10000) );

CREATE SEQUENCE ESFSEQ;

CREATE TABLE ENTRYSFS (
 ID INTEGER NOT NULL,
 SEQ INTEGER,
 CATEGORY VARCHAR(127),
 NAME VARCHAR(127),
 LINE INTEGER NOT NULL,
 COL INTEGER,
 PRECOMMENT VARCHAR(10000) );

CREATE SEQUENCE ELOOPSEQ;

CREATE TABLE ENTRYLOOPS (
 ID INTEGER NOT NULL,
 SFID INTEGER NOT NULL,
 LINE INTEGER NOT NULL,
 COL INTEGER,
 PRECOMMENT VARCHAR(10000));

CREATE SEQUENCE ETAGSEQ;

CREATE TABLE ENTRYTAGS (
 ID INTEGER NOT NULL,
 SFID INTEGER NOT NULL,
 LOOPID INTEGER,
 SEQ INTEGER,
 NAME VARCHAR(127) NOT NULL,
 LINE INTEGER NOT NULL,
 COL INTEGER,
 PRECOMMENT VARCHAR(10000));

CREATE SEQUENCE EVALSEQ;

CREATE TABLE ENTRYVALS ( 
 ID INTEGER NOT NULL,
 TAGID INTEGER NOT NULL,
 LOOPID INTEGER,
 SEQ INTEGER,
 VAL VARCHAR(10000),
 DELIMITER INTEGER NOT NULL,
 LINE INTEGER NOT NULL,
 COL INTEGER,
 LOOPROW INTEGER,
 PRECOMMENT VARCHAR(10000)); 

CREATE VIEW ENTRYRESTYPES AS
SELECT DISTINCT v.VAL AS ENTITY, iv.VAL AS EID
FROM ENTRYVALS v, ENTRYVALS iv, ENTRYTAGS t, ENTRYTAGS it
WHERE t.NAME='_Entity.Polymer_type' AND it.NAME='_Entity.ID'
AND it.SFID=t.SFID AND v.TAGID=t.ID AND iv.TAGID=it.ID;

COMMIT;

