--
-- Add foreign key constraints
--
--
-- residues
--
ALTER TABLE RESIDUES ADD FOREIGN KEY (TYPEID) REFERENCES RESTYPES (ID) ON DELETE CASCADE;
ALTER TABLE RESIDUES ADD FOREIGN KEY (NOMID) REFERENCES NOMENCLATURES (ID) ON DELETE CASCADE;

--
-- residue map
--
ALTER TABLE RESNOM ADD FOREIGN KEY (BMRBID) REFERENCES RESIDUES (ID) ON DELETE CASCADE;
ALTER TABLE RESNOM ADD FOREIGN KEY (RESID) REFERENCES RESIDUES (ID) ON DELETE CASCADE;

--
-- atoms
--
ALTER TABLE ATOMS ADD FOREIGN KEY (RESID) REFERENCES RESIDUES (ID) ON DELETE CASCADE;
ALTER TABLE ATOMS ADD FOREIGN KEY (NOMID) REFERENCES NOMENCLATURES (ID) ON DELETE CASCADE;

--
-- ambiguity codes
--
ALTER TABLE AMBICODES ADD FOREIGN KEY (ATOMID) REFERENCES ATOMS (ID) ON DELETE CASCADE;

--
-- pseudo atoms
--
ALTER TABLE PSEUDOS ADD FOREIGN KEY (ID) REFERENCES ATOMS (ID) ON DELETE CASCADE;
ALTER TABLE PSEUDOS ADD FOREIGN KEY (ATOMID) REFERENCES ATOMS (ID) ON DELETE CASCADE;

--
-- atom map
--
ALTER TABLE ATOMNOM ADD FOREIGN KEY (BMRBID) REFERENCES ATOMS (ID) ON DELETE CASCADE;
ALTER TABLE ATOMNOM ADD FOREIGN KEY (ATOMID) REFERENCES ATOMS (ID) ON DELETE CASCADE;

--
-- chemical shifts
--
ALTER TABLE CHEMSHIFTS ADD FOREIGN KEY (ATOMID) REFERENCES ATOMS (ID) ON DELETE CASCADE;

--
-- ambiguity code replacement
--
ALTER TABLE AMBIREPLACE ADD FOREIGN KEY (RESID) REFERENCES RESIDUES (ID) ON DELETE CASCADE;
ALTER TABLE AMBIREPLACE ADD FOREIGN KEY (ATOMID1) REFERENCES ATOMS (ID) ON DELETE CASCADE;
ALTER TABLE AMBIREPLACE ADD FOREIGN KEY (ATOMID2) REFERENCES ATOMS (ID) ON DELETE CASCADE;
